summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorNatanael Copa <ncopa@alpinelinux.org>2019-11-07 15:59:01 +0000
committerNatanael Copa <ncopa@alpinelinux.org>2019-11-07 16:02:47 +0000
commit95cd15c02501ec178a69333d136207f695550044 (patch)
treea30343acefaef90276bd158bf5b5590ebe2364f8
parent21dcfb1f21ac651cd4753100fe08d54402ecda0d (diff)
downloadabuild-95cd15c02501ec178a69333d136207f695550044.tar.bz2
abuild-95cd15c02501ec178a69333d136207f695550044.tar.xz
functions.sh: dont die if gcc is missing
abuild-sign does not use gcc. fixes #9974
-rw-r--r--functions.sh.in2
-rw-r--r--tests/functions.bats11
2 files changed, 12 insertions, 1 deletions
diff --git a/functions.sh.in b/functions.sh.in
index 435b240..6d5181a 100644
--- a/functions.sh.in
+++ b/functions.sh.in
@@ -117,7 +117,7 @@ readconfig() {
USE_COLORS=${_USE_COLORS-$USE_COLORS}
USE_CCACHE=${_USE_CCACHE-$USE_CCACHE}
- [ -z "$CBUILD" ] && CBUILD="$(gcc -dumpmachine)"
+ [ -z "$CBUILD" ] && CBUILD="$(${CC:-gcc} -dumpmachine 2>/dev/null || true)"
[ -z "$CHOST" ] && CHOST="$CBUILD"
[ -z "$CTARGET" ] && CTARGET="$CHOST"
[ "$(arch_to_hostspec $CBUILD)" != "unknown" ] && CBUILD="$(arch_to_hostspec $CBUILD)"
diff --git a/tests/functions.bats b/tests/functions.bats
new file mode 100644
index 0000000..9ae832a
--- /dev/null
+++ b/tests/functions.bats
@@ -0,0 +1,11 @@
+setup() {
+ export FUNCS=../functions.sh
+}
+
+@test "check if CBUILD is set" {
+ . $FUNCS && test -n "$CBUILD"
+}
+
+@test "check that missing gcc does not kill us" {
+ sh -e -c "CC=false; . $FUNCS && test -z \"$CBUILD\""
+}